//
// VNC Viewer for B-right/V
// (C)Copyright 2004, Yashiro Takeshi
//

// ----------------------------------------------------
//  ᥤ󥦥ɥ
// ----------------------------------------------------

#include "VncWindow.h"
#include "rfbTransactions.h"
#include "ylockobject.h"
#include "databox.h"
#include <bstdio.h>
#include <string>

extern DEV_SPEC SCREEN;

// ̹ѤΥ (win->onDraw˸ƤФ)
// Ʊ !!!
static void displayWaiter(W arg)
{
  VncWindow *win = (VncWindow*)arg;
  while (true){
    if (win->flg_redisp){
      W gid = wget_gid(win->getWindowID());
      {
        YLockObject guard(&(win->disp_sem));
        grst_bmp(gid, &(win->bmp.bounds), &(win->bmp), 
                 &(win->bmp.bounds), NULL, G_STORE);
      }
      win->flg_redisp = false;
    }
    slp_tsk(5000);
  }
}

// -----

VncWindow::VncWindow()
  : sem(), disp_sem(), YWindow()
{
  emk = chg_emk(-1);
  downCount = 0;

  mouseBtnStatus = 0;
  pictogram = 17;
  disp_task_id = -1;
  flg_redisp = false;

  // ĤɻߤΤ
  background.spat.kind = 0;
  background.spat.hsize = 1;
  background.spat.vsize = 1;
  background.spat.fgcol = 0x90ffffff;
  background.spat.bgcol = 0x90000000;
  background.spat.mask = FILL0;
}

void VncWindow::normalizeScrollBars()
{
  // scroll bars (to be put into YScrollWindow later)
  
  // normalize x-direction
  if (bbar[0] - bbar[1] >= bbar[2] - bbar[3]){
    bbar[1] = bbar[3];
    bbar[0] = bbar[2];
  }
  else {
    if (bbar[0] > bbar[2]){
      wscr_wnd(windowID, NULL, bbar[0]-bbar[2], 0, W_MOVE | W_RDSET);
      bbar[1] -= bbar[0] - bbar[2];
      bbar[0] = bbar[2];
    }
    else if (bbar[3] > bbar[1]){
      wscr_wnd(windowID, NULL, bbar[1]-bbar[3], 0, W_MOVE | W_RDSET);
      bbar[0] += bbar[3] - bbar[1];
      bbar[1] = bbar[3];
    }
  }
  // normalize y-direction
  if (rbar[1] - rbar[0] >= rbar[3] - rbar[2]){
    rbar[0] = rbar[2];
    rbar[1] = rbar[3];
  }
  else {
    if (rbar[1] > rbar[3]){
      wscr_wnd(windowID, NULL, rbar[1]-rbar[3], 0, W_MOVE | W_RDSET);
      rbar[0] -= rbar[1] - rbar[3];
      rbar[1] = rbar[3];
    }
    else if (rbar[2] > rbar[0]){
      wscr_wnd(windowID, NULL, rbar[2]-rbar[0], 0, W_MOVE | W_RDSET);
      rbar[1] += rbar[2] - rbar[0];
      rbar[0] = rbar[2];
    }
  }
  //printf("(%d %d)-(%d %d)\n", bbar[3], rbar[2], bbar[2], rbar[3]);
  //printf("(%d %d)-(%d %d)\n", bbar[1], rbar[0], bbar[0], rbar[1]);
}

void VncWindow::setWorkArea(YRect *rect)
{
  //YRect rect;
  W bbar_pid, rbar_pid;
  W gid = wget_gid(windowID);
  wget_bar(windowID, &rbar_pid, &bbar_pid, NULL);
  bbar[1] = rect->left; //pos.x
  bbar[0] = rect->right;
  rbar[0] = rect->top; //pos.y
  rbar[1] = rect->bottom;
  normalizeScrollBars();
  cset_val(bbar_pid, 4, bbar);
  cset_val(rbar_pid, 4, rbar);
  rect->setRect(bbar[1], rbar[0], bbar[0], rbar[1]);
  wset_wrk(windowID, (RECT*)rect);
  gset_vis(gid, *rect);
}

void VncWindow::openWindow()
{
  int oldWindowID = windowID;
  YWindow::openWindow();

  // Ĥɻ
  wset_bgp(windowID, &background);
  
  if (oldWindowID < 0){
    // BMP Creation
    TC devName[11];
    DEV_SPEC ds;
    
    W gid = wget_gid(windowID);
    gget_dev(gid, devName);
    gget_spc(devName, &ds);
    cs0.attr = ds.attr & 0xf;
    cs0.info[0] = ds.color[0];
    cs0.info[1] = ds.color[1];
    cs0.info[2] = ds.color[2];
    cs0.info[3] = ds.color[3];
    cs0.colmap = 0;
    bmp.planes = ds.planes;
    bmp.pixbits = ds.pixbits;
    setrect(bmp.bounds, 0, 0, server->framebufferWidth,
            server->framebufferHeight);
    bmalloc(&bmp);
    mem_gid = gopn_mem(NULL, &bmp, (B*)&cs0);
    PAT pat = {{ 0, 2, 2, 0x10ffffff, 0x10000000, FILL50 }};
    gfil_rec(mem_gid, bmp.bounds, &pat, 0, G_STORE);

    // scroll bars (to be put into YScrollWindow later)
    YRect rect;
    bbar[3] = 0;
    bbar[2] = bbar[3] + server->framebufferWidth;
    rbar[2] = 0;
    rbar[3] = rbar[2] + server->framebufferHeight;
    wget_wrk(windowID, (RECT*)&rect);
    setWorkArea(&rect);

    // Calculate scroll-bars & title-bars size
    WDSTAT stat;
    wget_sts(windowID, &stat, NULL);
    barsz.h = stat.r.c.right - stat.r.c.left
      - stat.wr.c.right + stat.wr.c.left;
    barsz.v = stat.r.c.bottom - stat.r.c.top
      - stat.wr.c.bottom + stat.wr.c.top;

    // Create Receiver
    task_id = cre_tsk(vncDataReceiver, -1, (W)this);
  }
}

void VncWindow::closeWindow()
{
  if (windowID >= 0){
    WDSTAT stat;
    wget_sts(windowID, &stat, NULL);
    position = stat.r;
    max_tmp = (((stat.attr & WA_FULL) != 0) ? 1 : 0); 
    gcls_env(mem_gid);
    bfree(&bmp);
    ter_tsk(task_id);
    chg_emk(emk);
  }
  if (disp_task_id >= 0){
    ter_tsk(disp_task_id);
    disp_task_id = -1;
  }
  YWindow::closeWindow();
}

void VncWindow::onDraw(YGraphic *gr)
{
  if (disp_task_id < 0){
    disp_task_id = cre_tsk(displayWaiter, -1, (W)this);
  }
  flg_redisp = true;
  wup_tsk(disp_task_id);
  
  YRect work;
  static PAT pouts = {{ 0, 2, 2, 0x10ffffff, 0x10000000, FILL50 }};
  wget_wrk(windowID, (RECT*)&work);
  if (work.width() > server->framebufferWidth){
    YRect r(server->framebufferWidth, 0, work.right, work.bottom);
    gfil_rec(gr->getGraphID(), r, &pouts, 0, G_STORE);
  }
  if (work.height() > server->framebufferHeight){
    YRect r(0, server->framebufferHeight, work.right, work.bottom);
    gfil_rec(gr->getGraphID(), r, &pouts, 0, G_STORE);
  }
}

void VncWindow::onIdle(WEVENT *ev)
{
  YPoint pt(-100, -100);
  static char old_mouseBtnStatus = mouseBtnStatus;
  
  // Status Keys
  UW oldStatus = metaKeyStatus;
  metaKeyStatus = ev->s.stat & ~(ES_BUT | ES_BUT2);
  execVNCStatusKeyEvent(sock, metaKeyStatus, oldStatus);
  
  if (ev->s.cmd != W_WORK){
    return;
  }
  if (ev->s.wid != windowID){
    gset_ptr(PS_SELECT, 0, (unsigned int)-1, (unsigned int)-1);
    return;
  }
  gset_ptr(-1, (PTRIMG*)getdbox(VNC_POINTER), (unsigned int)-1, (unsigned int)-1);
  
  mouseBtnStatus = (ev->s.stat & ES_BUT) | ((ev->s.stat & ES_BUT2) << 1);
  
  if (pt != ev->s.pos || mouseBtnStatus != old_mouseBtnStatus){
    YRect rect(0, 0, server->framebufferWidth, server->framebufferHeight);
    if (rect.isInside(ev->s.pos)){
      pt = ev->s.pos;
      execVNCMouseEvent(sock, &sem, pt, mouseBtnStatus);
      // rectϰϤʤ٤
      requestVNCFramebufferUpdate(sock, &sem, rect, false);
    }
  }
}

void VncWindow::onMouseButtonUp(WEVENT *ev)
{
  YPoint pt = ev->s.pos;
  mouseBtnStatus = (ev->s.stat & ES_BUT) | ((ev->s.stat & ES_BUT2) << 1);
  if (ev->s.cmd == W_WORK){
    YRect rect(0, 0, server->framebufferWidth, server->framebufferHeight);
    if (rect.isInside(pt)){
      execVNCMouseEvent(sock, &sem, pt, mouseBtnStatus);
      // rectϰϤʤ٤
      requestVNCFramebufferUpdate(sock, &sem, rect, false);
    }
  }
  else {
    YWindow::onMouseButtonUp(ev);
  }
}

void VncWindow::usualMouseButtonDown(WEVENT *ev)
{
  // ̤ξΥޥܥν
  // YScrollWindowؤΰܿͤȤꤢʬΥƤ
  W clt;
  if (ev->s.cmd != W_BBAR && ev->s.cmd != W_RBAR){
    clt = wchk_dck(ev->s.time);
  }
  W mode;
  
  switch (ev->s.cmd){
  case W_WORK:
    // TODO: ν˰ܴ
    break;
    
  case W_LTHD:
  case W_LBHD:
  case W_RTHD:
  case W_RBHD:
    {
      W gid = wget_gid(windowID);
      YRect rect;
      W bbar_pid, rbar_pid;
      wget_bar(windowID, &rbar_pid, &bbar_pid, NULL);
      
      if (clt == W_DCLICK){
        maximizeWindow();
      }
      else if (clt == W_PRESS || clt == W_QPRESS){
        YRect limit(0, 0, server->framebufferWidth + barsz.h,
                    server->framebufferHeight + barsz.v);
        wrsz_drg(ev, (RECT*)&limit, (RECT*)&position); // update flag..
        YRect rect;
        wget_wrk(windowID, (RECT*)&rect);
        setWorkArea(&rect);
        onRepaint();
      }
      // nothing to be done for W_CLICK
    }
    break;
    
  case W_PICT:
    if (clt == W_DCLICK){
      closeWindow();
    }
    else if (clt == W_CLICK){
      break; // no-operation
    }
  case W_TITL:
  case W_FRAM:
    if (clt == W_PRESS || clt == W_QPRESS){ // ɲ
      if (wmov_drg(ev,NULL) > 0){
        onRepaint();
      }
    }
    break;
    
    // scroll-bars
  case W_LBAR:
    break;
  case W_RBAR:
    {
      if (rbar[1] == rbar[2] && rbar[0] == rbar[3]){
        break;
      }
      YRect rect;
      W rbar_pid, act;
      wget_wrk(windowID, (RECT*)&rect);
      wget_bar(windowID, &rbar_pid, NULL, NULL);
      for (bool cont = true; cont;) {
        int incr = 0;
        act = cact_par(rbar_pid, ev);
        cget_val(rbar_pid, 2, rbar);
        rect.top = rbar[0];
        switch (act){
        case 0x6000: // up(press)
          incr = 5;
          if (rbar[0] - incr < rbar[2]){
            incr = rbar[0] - rbar[2];
          }
          wscr_wnd(windowID, NULL, 0, incr, W_SCRL | W_RDSET);
          rbar[0] -= incr;
          rbar[1] -= incr;
          cset_val(rbar_pid, 2, rbar);
          break;
        case 0x6001: // down(press)
          incr = 5;
          if (rbar[1] + incr > rbar[3]){
            incr = rbar[3] - rbar[1];
          }
          wscr_wnd(windowID, NULL, 0, -incr, W_SCRL | W_RDSET);
          rbar[0] += incr;
          rbar[1] += incr;
          cset_val(rbar_pid, 2, rbar);
          break;
        case 0x5004: // up(dck)
          incr = 100;
          if (rbar[0] - incr < rbar[2]){
            incr = rbar[0] - rbar[2];
          }
          wscr_wnd(windowID, NULL, 0, incr, W_SCRL | W_RDSET);
          rbar[0] -= incr;
          rbar[1] -= incr;
          cset_val(rbar_pid, 2, rbar);
          cont = false;
          break;
        case 0x5005: // down(dck)
          incr = 100;
          if (rbar[1] + incr > rbar[3]){
            incr = rbar[3] - rbar[1];
          }
          wscr_wnd(windowID, NULL, 0, -incr, W_SCRL | W_RDSET);
          rbar[0] += incr;
          rbar[1] += incr;
          cset_val(rbar_pid, 2, bbar);
          cont = false;
          break;
        case 0x5008: // drag(up)
        case 0x5009: // drag(down)
          cont = false;
          wreq_dsp(windowID);
          break;
        default:
          cont = false;
        };
      } //while (act & 0x6000 == 0x6000);
      rect.left = bbar[1];
      rect.top = rbar[0];
      wset_wrk(windowID, (RECT*)&rect);
      setWorkArea(&rect);
      onRepaint();
    }
    break;    
    
  case W_BBAR:
    {
      if (bbar[0] == bbar[3] && bbar[1] == bbar[2]){
        break;
      }
      YRect rect;
      W bbar_pid, act;
      wget_wrk(windowID, (RECT*)&rect);
      wget_bar(windowID, NULL, &bbar_pid, NULL);
      for (bool cont = true; cont;) {
        int incr = 0;
        act = cact_par(bbar_pid, ev);
        cget_val(bbar_pid, 2, bbar);
        rect.left = bbar[1];
        switch (act){
        case 0x6002: // left(press)
          incr = 5;
          if (bbar[1] - incr < bbar[3]){
            incr = bbar[1] - bbar[3];
          }
          wscr_wnd(windowID, NULL, incr, 0, W_SCRL | W_RDSET);
          bbar[1] -= incr;
          bbar[0] -= incr;
          cset_val(bbar_pid, 2, bbar);
          break;
        case 0x6003: // right(press)
          incr = 5;
          if (bbar[0] + incr > bbar[2]){
            incr = bbar[2] - bbar[0];
          }
          wscr_wnd(windowID, NULL, -incr, 0, W_SCRL | W_RDSET);
          bbar[1] += incr;
          bbar[0] += incr;
          cset_val(bbar_pid, 2, bbar);
          break;
        case 0x5006: // left(dck)
          incr = 100;
          if (bbar[1] - incr < bbar[3]){
            incr = bbar[1] - bbar[3];
          }
          wscr_wnd(windowID, NULL, incr, 0, W_SCRL | W_RDSET);
          bbar[1] -= incr;
          bbar[0] -= incr;
          cset_val(bbar_pid, 2, bbar);
          cont = false;
          break;
        case 0x5007: // right(dck)
          incr = 100;
          if (bbar[0] + incr > bbar[2]){
            incr = bbar[2] - bbar[0];
          }
          wscr_wnd(windowID, NULL, -incr, 0, W_SCRL | W_RDSET);
          bbar[1] += incr;
          bbar[0] += incr;
          cset_val(bbar_pid, 2, bbar);
          cont = false;
          break;
        case 0x500a: // drag(left)
        case 0x500b: // drag(right)
          wreq_dsp(windowID);
          cont = false;
          break;
        default:
          cont = false;
        };
      } //while (act & 0x6000 == 0x6000);
      rect.left = bbar[1];
      rect.top = rbar[0];
      wset_wrk(windowID, (RECT*)&rect);
      setWorkArea(&rect);
      onRepaint();
    }
    break;
    
  case W_SWITCH:
    // ΰΰĤȽ񤤤Ƥ뤱ɡ
    break;
    
  case W_CLOSED:
    // ҥɥĤ
    break;
    
  }
}

void VncWindow::onMouseButtonDown(WEVENT *ev)
{
  YPoint pt = ev->s.pos;
  mouseBtnStatus = (ev->s.stat & ES_BUT) | ((ev->s.stat & ES_BUT2) << 1);
  if (ev->s.cmd == W_WORK){
    YRect rect(0, 0, server->framebufferWidth, server->framebufferHeight);
    if (rect.isInside(pt)){
      execVNCMouseEvent(sock, &sem, pt, mouseBtnStatus);
    }
    // rectϰϤʤ٤
    requestVNCFramebufferUpdate(sock, &sem, rect, false);
  }
  else {
    usualMouseButtonDown(ev);
  }
}

void VncWindow::onKeyDown(WEVENT *ev)
{
  if (downCount <= 0 || chg_emk(-1) != 0x7fff){
    emk = chg_emk(0x7fff);
  }
  downCount++;
  
  UW oldStatus = metaKeyStatus;
  metaKeyStatus = ev->s.stat & ~(ES_BUT | ES_BUT2);
  execVNCStatusKeyEvent(sock, metaKeyStatus, oldStatus);
}

void VncWindow::onKeyTyped(WEVENT *ev)
{
  execVNCKeyEvent(sock, ((EVENT*)ev)->data.key.keytop, true, metaKeyStatus);
}

void VncWindow::onKeyUp(WEVENT *ev)
{
  downCount--;
  if (chg_emk(-1) != 0x7fff){
    emk = chg_emk(0x7fff);
  }
  if (downCount <= 0){
    chg_emk(emk);
  }

  execVNCKeyEvent(sock, ((EVENT*)ev)->data.key.keytop, false, metaKeyStatus);
  UW oldStatus = metaKeyStatus;
  metaKeyStatus = ev->s.stat & ~(ES_BUT | ES_BUT2);
  execVNCStatusKeyEvent(sock, metaKeyStatus, oldStatus);
}

void VncWindow::onMouseWheel(WEVENT *ev)
{
  //printf("wheel: %4x\n", ((EVENT*)ev)->data.key.keytop);
  int num = ((EVENT*)ev)->data.key.keytop - 0x8000;
  gcnv_rel(wget_gid(wget_act(NULL)), &(ev->s.pos));
  if (!(ev->s.pos.x >= 0 && ev->s.pos.x < server->framebufferWidth &&
        ev->s.pos.y >= 0 && ev->s.pos.y < server->framebufferHeight)){
    return;
  }
  if (num > 0){
    for (int i = 0; i < num; i++){
      mouseBtnStatus |= 16;
      execVNCMouseEvent(sock, &sem, ev->s.pos, mouseBtnStatus);
      mouseBtnStatus &= (~16);
      execVNCMouseEvent(sock, &sem, ev->s.pos, mouseBtnStatus);
    }
  }
  else {
    for (int i = 0; i < -num; i++){
      mouseBtnStatus |= 8;
      execVNCMouseEvent(sock, &sem, ev->s.pos, mouseBtnStatus);
      mouseBtnStatus &= (~8);
      execVNCMouseEvent(sock, &sem, ev->s.pos, mouseBtnStatus);
    }
  }
}

void VncWindow::onMenu(int sel)
{
  switch (sel >> 8){
  case 0:
    // λ
    closeWindow();
    break;
  case 1:
    // ɽ
    switch (sel & 0xff){
    case 1:
      // ɽ
      maximizeWindow();
      break;
    case 2:
      // ɽ
      wreq_dsp(windowID);
      break;
    }
    break;
  case 2:
    // ȥ졼
    switch (sel & 0xff){
    case 1:
      // ƥ
      {
        W size;
        if (tpop_dat(NULL, 1, &size, -1, NULL) > 0){
          std::string str;
          char tmp[3];
          B* data = new B[size+1];
          int n = tpop_dat((TRAYREC*)data, size, &size, -1, NULL);
          for (int i = 0; i < n; i++){
            if (((TRAYREC*)data)[i].id == TR_TEXT){
              for (int j = 0; j < ((TRAYREC*)data)[i].len; j += 2){
                TC ch = *((TC*)(&(((TRAYREC*)data)[i].dt[j])));
                if ((unsigned short)ch >= 0xff80U &&
                    (unsigned short)ch <= 0xfffeU){
                  // tad segment;
                  j += *((unsigned short*)(&(((TRAYREC*)data)[i].dt[j+2])));
                  //do 'NOT' j += 2 here
                  j += 2;
                  continue;
                }
                W n;
                if (isTLANGch(ch, &n) != 0){
                  j += 2;
                  continue;
                }
                int ls = tctosj((UB*)tmp, ch);
                if (ls > 0){
                  tmp[ls] = '\0';
                  str += tmp;
                }
              }
            }
          }
          if (!str.empty()){
            execClientCutText(sock, str);
          }
          delete data;
        }        
      }
      break;
    case 2:
      // ƥȼ
      {
        TRAYREC tray[2];
        TEXTSEG tseg = {
          {{0, 0, 0, 0}},
          {{0, 0, 0, 0}},
          -120, -120,
          0x21, 0
        };
        tray[0].id = TS_TEXT;
        tray[0].len = sizeof(TEXTSEG);
        tray[0].dt = (B*)&tseg;
        tray[1].id = TR_TEXT;
        tray[1].len = tc_strlen(trayString)*2 + 2;
        tray[1].dt = (B*)((const TC*)trayString);
        tpsh_dat(tray, 2, NULL);
      }
      break;
    }
    break;
  case 3:
    // ɥ
    wexe_dmn(sel);
    break;
  case 4:
    // ʪ
    oexe_apg(0, sel);
    break;
  }
  return;
}

void VncWindow::maximizeWindow()
{
  if (SCREEN.hpixels > server->framebufferWidth + barsz.h ||
      SCREEN.vpixels > server->framebufferHeight + barsz.v){
    YRect rect(0,0,0,0);
    wmov_wnd(windowID, (RECT*)&rect);
    rect.bottom = rect.top + server->framebufferHeight + barsz.v;
    rect.right = rect.left + server->framebufferWidth + barsz.h;
    if (rect.right > SCREEN.hpixels)
      rect.right = SCREEN.hpixels;
    if (rect.bottom > SCREEN.vpixels)
      rect.bottom = SCREEN.vpixels;
    wrsz_wnd(windowID, (RECT*)&rect);
    wget_wrk(windowID, (RECT*)&rect);
    setWorkArea(&rect);
    onRepaint();
  }
  else if (wchg_wnd(windowID, (RECT*)&position, W_MOVE) == W_FULL){
    YRect rect;
    wget_wrk(windowID, (RECT*)&rect);
    setWorkArea(&rect);
    onRepaint();
  }
}
