//
// VNC Viewer for B-right/V
// (C)Copyright 2004, Yashiro Takeshi
//

// ----------------------------------------------------
//  ᥤ󥦥ɥ
// ----------------------------------------------------

#ifndef DEFINE_H_VNCWINDOW
#define DEFINE_H_VNCWINDOW

#include <basic.h>
#include <btron/dp.h>
#include <keycode.h>
#include "ywindow.h"

#include "ysemaphore.h"
#include "ytcpsocket.h"
#include "rfbproto.h"

class VncWindow : public YWindow {
  friend void vncDataReceiver(W arg);
  PAT background;

protected:
  W rbar[4], bbar[4]; // scrl
  H max_tmp;
  SIZE barsz;

public:
  YLibDraft::YTCPSocket *sock;
  YSemaphore sem, disp_sem;
  rfbServerInitMsg *server;
  BMP bmp;
  CSPEC cs0;
  W mem_gid;
  W task_id;
  W disp_task_id;
  bool flg_redisp;
  char mouseBtnStatus;
  UW metaKeyStatus;
  W mid;
  YString trayString;
  W emk;
  int downCount;
  
public:
  VncWindow();
  virtual void openWindow();
  virtual void closeWindow();
  virtual void onDraw(YGraphic *gr);
  virtual void onIdle(WEVENT *ev);
  virtual void onMouseButtonUp(WEVENT *ev);
  virtual void onMouseButtonDown(WEVENT *ev);
  virtual void onKeyTyped(WEVENT *ev);
  virtual void onKeyDown(WEVENT *ev);
  virtual void onKeyUp(WEVENT *ev);
  virtual void onMouseWheel(WEVENT *ev);
  virtual void onMenu(int sel);
  void getPosition(YRect *rect, H* full){
    // ξ줷ΤǺäΡѤʤȡ
    if (windowID >= 0){
      WDSTAT stat;
      wget_sts(windowID, &stat, NULL);
      position = stat.r;
      max_tmp = (((stat.attr & WA_FULL) != 0) ? 1 : 0); 
    }
    *rect = position;
    *full = max_tmp;
  }
  void maximizeWindow();

  // 򥪡С饤ɤСʤʤɤOKˤʤ롣
  virtual void normalizeScrollBars();
  void setWorkArea(YRect* rect);

  void usualMouseButtonDown(WEVENT *ev);
};

#endif // DEFINE_H_VNCWINDOW
