//
// VNC Viewer for B-right/V
// (C)Copyright 2004, Yashiro Takeshi
//

#include "ytcpsocket.h"
#include "rfbproto.h"
#include <string>

class YSemaphore;

// ----------------------------------------------------
//  RFB ץȥط
// ----------------------------------------------------

#ifndef DEFINE_H_RFBTRANSACTIONS
#define DEFINE_H_RFBTRANSACTIONS

#ifndef RFBTRANSACTIONS_IMPL

extern bool execVNCProtocolVersion(YLibDraft::YTCPSocket* sock, int* ver, int* subver);
extern int execVNCAuthentication(YLibDraft::YTCPSocket* sock, char* passwd);
extern TC* execVNCServerInitalization(YLibDraft::YTCPSocket* sock, rfbServerInitMsg *msg);
extern void execVNCSetEncoding(YLibDraft::YTCPSocket* sock);
extern void execVNCSetPixelFormat(YLibDraft::YTCPSocket* sock, rfbServerInitMsg* server);
extern void execVNCMouseEvent(YLibDraft::YTCPSocket* sock, YSemaphore* sem, const YPoint& pt, char sts);
extern void requestVNCFramebufferUpdate(YLibDraft::YTCPSocket* sock, YSemaphore* sem, const YRect &rect, bool first = false);
extern void vncDataReceiver(W arg);
extern void execFramebufferUpdate(YLibDraft::YTCPSocket *sock, YSemaphore* disp_sem, rfbServerInitMsg *server, W wid, W gid);
extern unsigned long convertVNCKey(TC keycode);
extern void execVNCKeyEvent(YLibDraft::YTCPSocket *sock, UH key, bool down, UW status);
extern void execVNCStatusKeyEvent(YLibDraft::YTCPSocket *sock, UW status, UW oldstatus);
extern void execClientCutText(YLibDraft::YTCPSocket *sock, const std::string& str);

#endif // RFBTRANSACTIONS_IMPL

#endif // DEFINE_H_RFBTRANSACTIONS


