/**
 * @file yrect.h
 * @brief Ĺΰ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-30
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YRECT
#define DEFINE_H_YRECT

#include <basic.h>
#include <bstdlib.h>
#include <tcode.h>
#include <errcode.h>
#include <btron/btron.h>
#include <btron/dp.h>
#include "ypoint.h"

/** Ĺΰ륯饹
 *
 * Ĺΰݻ륯饹RECT¤ΤΥåѤˤʤäƤꡢ
 * <strong>ľleft, right, bottom, top˥Ǥ</strong>Ȥ
 */
class YRect : public RECT::_rect {
public:
  /// ǥեȥ󥹥ȥ饯
  YRect() {}
  
  /** 󥹥ȥ饯
   *
   * 󥹥ȥ饯ꤵ줿ɸǽ롣
   * @param x1 Xɸ
   * @param y1 Yɸ
   * @param x2 Xɸ
   * @param y2 Yɸ
   */
  YRect(W x1, W y1, W x2, W y2) {
    setRect(x1, y1, x2, y2);
  }

  /** ԡ󥹥ȥ饯
   *
   * ԡ󥹥ȥ饯ĹΰƤ򥳥ԡޤ
   * @param src ԡ
   */
  YRect(const YRect& src) {
    operator=(src);
  }

  /** ԡ󥹥ȥ饯
   *
   * ԡ󥹥ȥ饯ĹΰƤ򥳥ԡޤ
   * @param src ԡ
   */
  YRect(const RECT& src) {
    operator=(src);
  }

  /** 󥹥ȥ饯
   *
   * 󥹥ȥ饯ꤵ줿ɸǽ롣
   * @param p1 κɸ
   * @param p2 κɸ
   */
  YRect(const PNT& p1, const PNT& p2) {
    setRect(p1, p2);
  }

  /// ǥȥ饯
  ~YRect() {}

  /** ɸ
   *
   * ɸޤ
   *
   * @param x1 Xɸ
   * @param y1 Yɸ
   * @param x2 Xɸ
   * @param y2 Yɸ
   */
  void setRect(W x1, W y1, W x2, W y2) {
    left = x1;
    top = y1;
    right = x2;
    bottom = y2;
  }

  /** ɸ
   *
   * ɸޤ
   *
   * @param x1 Xɸ
   * @param y1 Yɸ
   * @param x2 Xɸ
   * @param y2 Yɸ
   */
  void setRect(const PNT& p1, const PNT& p2) {
    setRect(p1.x, p1.y, p2.x, p2.y);
  }

  /** κɸ
   *
   * κɸޤ
   * @return κɸ
   */
  const YPoint& topLeft() const {
    return *((YPoint*)&((RECT*)this)->p.lefttop);
  }

  /** κɸ
   *
   * κɸޤ
   * @return κɸ
   */
  const YPoint& bottomRight() const {
    return *((YPoint*)&((RECT*)this)->p.rightbot);
  }


  /** 濴κɸ׻
   *
   * 濴κɸ׻롣YPoint֥ȤϿ롣
   * @return 濴κɸ
   */
  YPoint center() const {
    return YPoint((right+left)/2, (top+bottom)/2);
  };
  
  /** ׻
   *
   * ͳѷΰ׻ޤ
   * @return 
   */
  W width() const {
    return right - left;
  }

  /** ͳѷν̾
   *
   * ͳѷΰ XY줾ξ¦ꤵ줿̤̤ޤ
   * ξ¦̤ޤΤǡΤȤ 2 * wx, 2 * wy ̤ޤ뤳Ȥ
   * դƤ
   * @param wx X¦ν̾
   * @param wy Y¦ν̾
   */
  void shrink(W wx, W wy){
    left += wx;
    right -= wx;
    top += wy;
    bottom -= wy;
  }

  /** ͳѷγ
   *
   * ͳѷΰ XY줾ξ¦ꤵ줿̤ޤ
   * ξ¦򹭤ΤǡΤȤ 2 * wx, 2 * wy 뤳Ȥ
   * դƤ
   * @param wx X¦γ
   * @param wy Y¦γ
   */
  void expand(W wx, W wy){
    shrink(-wx, -wy);
  }

  /** ⤵׻
   *
   * ͳѷΰι⤵׻ޤ
   * @return ⤵
   */
  W height() const { 
    return bottom - top;
  }
  
  /** 黻
   *
   * ɸޤ
   * @param src ɸ
   */
  const YRect& operator=(const RECT& src) {
    setRect(src.c.left, src.c.top, src.c.right, src.c.bottom);
    return *this;
  }
  
  /** 黻
   *
   * ɸޤ
   * @param src ɸ
   */
  const YRect& operator=(const YRect& src) {
    setRect(src.left, src.top, src.right, src.bottom);
    return *this;
  }

  ////////////////////////
  // ΰ+expư
  const YRect& operator+=(const PNT& exp) {
    top += exp.y;
    left += exp.x;
    right += exp.x;
    bottom += exp.y;
    return *this;
  }
  
  ////////////////////////
  // ΰ-expư
  const YRect& operator-=(const PNT& exp) {
    top -= exp.y;
    left -= exp.x;
    right -= exp.x;
    bottom -= exp.y;
    return *this;
  }
  
  /** ()
   *
   * ĤκɸɤӤޤ
   * @param exp Ӥоݤκɸ 
   */
  bool operator==(const YRect& exp) const {
    return (top == exp.top && left == exp.left &&
            right == exp.right && bottom == exp.bottom);
  }
  
  /** ()
   *
   * ĤκɸɤӤޤ
   * @param exp Ӥоݤκɸ 
   */
  bool operator==(const RECT& exp) const {
    return (top == exp.c.top && left == exp.c.left &&
            right == exp.c.right && bottom == exp.c.bottom);
  }
  
  /** ()
   *
   * Ĥκɸfalse, ۤʤtrue֤ޤ
   * @param exp Ӥоݤκɸ 
   */
  bool operator!=(const YRect& exp) const {
    return !(operator==(exp));
  }

  /** ()
   *
   * Ĥκɸfalse, ۤʤtrue֤ޤ
   * @param exp Ӥоݤκɸ 
   */
  bool operator!=(const RECT& exp) const {
    return !(operator==(exp));
  }
  
  /** const RECTؤѴ
   *
   * const RECTؤѴԤޤ
   */
  operator const RECT() const {
    return *reinterpret_cast<const RECT*>(this);
  }

  /** RECTؤѴ
   *
   * RECTؤѴԤޤ
   */
  operator RECT() {
    return *const_cast<RECT*>(reinterpret_cast<const RECT*>(this));
  }
  
  /** ˤ뤫ɤȽ
   *
   * Ϳ줿ˤɤȽǤޤHalf Open
   * Proprietary դƤ
   */
  bool isInside(const PNT &pnt) {
    return (left <= pnt.x && pnt.x < right && top <= pnt.y
            && pnt.y < bottom);
  }
  
protected:

private:

};

#endif // DEFINE_H_YRECT
