/**
 * @file ysemaphore.CC
 * @brief ޥե ()
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-31
 *
 * Copyright (C) 2004, Yashiro Takeshi
 */

#include <btron/gname.h>
#include "ysemaphore.h"
#include "ystring.h"
#include "ylockobject.h"

/// ޥեǻѤ륻ޥեIDμ
W YSemaphore::getInternalSemaphoreID() const
{
  W data;
  static TC sem_name[] = {L"٣̣¥ޥե"}; // Х̾
  
  if (get_nam(sem_name, &data) < 0){
    data = cre_sem(1, SEM_EXCL);
    cre_nam(sem_name, data, N_CREATE);
  }
  return data;
}

/// ޥե֥ȤμΤμ
// : ¾ϳ餫뤳ȡ
YSemaphoreInstance* YSemaphore::getInstance() const {
  if (sem == 0){
    sem = new YSemaphoreInstance;
    sem->sem_id = -1;
    sem->refcount = 1;
  }
  return sem;
}

/// ޥեλȸȤ򸺤餹
// : ¾ϳ餫뤳ȡ
void YSemaphore::reductInstanceReferrer() {
  if (sem != 0){
    sem->refcount--;
    if (sem->refcount <= 0){
      if (sem->sem_id > 0){
        del_sem(sem->sem_id);
        //sem->sem_id = -1;
      }
      delete sem;
      sem = 0;
    }
  }
}

/** 󥹥ȥ饯
 *
 * ޥեޤƱѤΥޥե
 * ⡼ɤȤ SEM_SYNC, ¾ѤΥޥեξ SEM_EXCL
 * ꤷƤ
 * @param cnt ȿν
 * @param mode ޥեץ
 */
YSemaphore::YSemaphore(W cnt = 1, W mode = SEM_EXCL) {
  sem = 0;
  this->mode = mode;
  max_count = cnt;
}

/** ԡ󥹥ȥ饯
 *
 * ƱƤΥޥեޤ
 * @param src ԡΥޥե
 */
YSemaphore::YSemaphore(const YSemaphore& src){
  max_count = src.max_count;
  mode = src.mode;
  
  W global_sem = getInternalSemaphoreID();
  wai_sem(global_sem, T_FOREVER);
  // ƥ륻󳫻
  try {
    sem = src.getInstance();
    sem->refcount++;
  }
  catch (...) {
    sig_sem(global_sem);
    throw;
  }
  // ƥ륻λ
  sig_sem(global_sem);
}

/** ޥեγ
 *
 * ޥեåޤ
 * @throw YSemaphoreException ¾ޥեλȤְäƤ
 */
void YSemaphore::lock() {
  YSemaphoreInstance *s = 0;
  W global_sem = getInternalSemaphoreID();
  wai_sem(global_sem, T_FOREVER);
  // ƥ륻󳫻
  try {
    s = getInstance();
    if (s->sem_id < 0){
      s->sem_id = cre_sem(max_count, mode);
    }
  }
  catch (...){
    sig_sem(global_sem);
    throw;
  }
  // ƥ륻λ
  sig_sem(global_sem);
  
  W err = wai_sem(s->sem_id, T_FOREVER);
  if (err < 0){
    YString msg((TC[]){L"¾ѤΥޥեФϢ³åޤ"});
    throw new YSemaphoreException(msg, err);
  }
}

/** ޥեβ
 *
 * ޥեåޤ
 * @throw YSemaphoreException ¾ޥեλȤְäƤ
 */
void YSemaphore::unlock() {
  YSemaphoreInstance *s = 0;
  W global_sem = getInternalSemaphoreID();
  wai_sem(global_sem, T_FOREVER);
  // ƥ륻󳫻
  try {
    s = getInstance();
    if (s->sem_id < 0){
      s->sem_id = cre_sem(max_count, mode);
    }
  }
  catch (...){
    sig_sem(global_sem);
    throw;
  }
  // ƥ륻λ
  sig_sem(global_sem);
  
  W err = sig_sem(s->sem_id);
  if (err < 0){
    YString msg((TC[]){L"¾ѤΥޥեФϢ³ƥåԤޤ"});
    throw new YSemaphoreException(msg, err);
  }
}

/** 黻
 *
 * ޥեޤ
 * @param src 륻ޥե
 */
const YSemaphore& YSemaphore::operator=(const YSemaphore& src)
{
  max_count = src.max_count;
  mode = src.mode;
  
  W global_sem = getInternalSemaphoreID();
  wai_sem(global_sem, T_FOREVER);
  // ƥ륻󳫻
  try {
    reductInstanceReferrer();
    sem = src.getInstance();
    sem->refcount++;
  }
  catch (...){
    sig_sem(global_sem);
    throw;
  }
  // ƥ륻λ
  sig_sem(global_sem);
}
