/**
 * @file ystring.h
 * @brief TRONʸ
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-30
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#ifndef DEFINE_H_YSTRING
#define DEFINE_H_YSTRING

#include <basic.h>
#include <bstdlib.h>
#include <errcode.h>
#include <tstring.h>
#include <tctype.h>
#include <tcode.h>
#include <wtstring.h>
#include <mtstring.h>
#include <tlang.h>
#include <btron/tf.h>

struct YStringInstance {
  int refcount; // ե󥹥
  TC *tcstr; // ʸμ
  int len; // ʸʸ
  int bufsize; // ХåեΥ
  int datalen; // ¥ǡΥ
  int lastzone; // ü֤Ǥʸ
};

/** TRONʸ
 *
 * ưŪ˥γݡԤTRONɲĹʸΥåѡ
 * 饹ǤʸΥԡԤäƤΤʣ줺ѹ
 * äԤäȤˡƼΤʣޤ
 *
 * ߤΤȤåɥդǤϤޤΤդƤ
 */
class YString {

public:
  /// ǥեȥ󥹥ȥ饯
  YString() {
    strInstance = NULL;
  }
  
  /// ǥȥ饯
  virtual ~YString() {
    freeInstance();
  }
  
  /// 󥹥ȥ饯
  YString(TC chr, int repeat);
  
  /** 󥹥ȥ饯
   *
   * 󥹥ȥ饯TC[]ʸȤ˽Ԥޤ
   * @param src ʸ
   */
  YString(const TC *src) {
    strInstance = NULL;
    operator=(src);
  }
  
  /** 󥹥ȥ饯
   *
   * 󥹥ȥ饯ʸ򥳥ԡޤ(Τʣޤ󤬡
   * ѹä줿Ȥˡ̼Τޤ
   * @param src ʸ
   */
  YString(const YString& src) {
    strInstance = NULL;
    operator=(src);
  }

  ////////////////////////
  // ʸ
  //   [in] - ԡʸ(YString)
  const YString& operator=(const YString& src);
  ////////////////////////
  // ʸ
  //   [in] - ԡʸ(TC*)
  const YString& operator=(const TC* src);

  ////////////////////////
  // TC[]ʸǡؤΥԤ(񤭹߶ػ)
  //   [out] const TC* - TC[]ʸǡؤconstݥ
  operator const TC*() const;
  
  ////////////////////////
  // ʸ礹
  //   [in] s1 - ʸ1
  //   [in] s2 - ʸ2
  //   [out] YString - ʸ
  friend YString concat(const TC* s1, const TC* s2);
  ////////////////////////
  // ʸ礹
  //   [in] s1 - ʸ1
  //   [in] s2 - ʸ2
  //   [out] YString - ʸ
  friend YString operator+(const YString& s1, const YString& s2);
  ////////////////////////
  // ʸ礹
  //   [in] str - ʸ1
  //   [in] tcs - ʸ2
  //   [out] YString - ʸ
  friend YString operator+(const YString& str, const TC* tcs);
  ////////////////////////
  // ʸ礹
  //   [in] tcs - ʸ1
  //   [in] str - ʸ2
  //   [out] YString - ʸ
  friend YString operator+(const TC* tcs, const YString& str);
  ////////////////////////
  // ʸʸ礹
  //   [in] str - ʸ
  //   [in] chr - TCʸ
  //   [out] YString - ʸ
  friend YString operator+(const YString& str, TC chr);
  ////////////////////////
  // ʸʸ礹
  //   [in] chr - TCʸ
  //   [in] str - ʸ
  //   [out] YString - ʸ
  friend YString operator+(TC chr, const YString& str);
  
  // GROUP: ̤
  

  ////////////////////////
  // ʬ
  //   [in] num - ʸ
  //   [out] YString - ʸʬ
  YString left(int ncount);
  ////////////////////////
  // ʬ
  //   [in] num - ʸ
  //   [out] YString - ʸʬ
  YString right(int ncount);
  ////////////////////////
  // Ǥʬ
  //   [in] st - гϰ
  //   [in] num - ʸ
  //   [out] YString - ʸʬ
  YString mid(int st, int num);
  ////////////////////////
  // ʬ
  //   [in] st - гϰ
  //   [out] YString - ʸʬ
  YString mid(int st);
  ////////////////////////
  // ХåեΥ
  //   [out] W - ХåեΥ
  W getBufferSize() const;
  ////////////////////////
  // ʸ
  //   [out] W - ХåեΥ
  W countLetter() const {
    if (strInstance == NULL) {
      return 0;
    }
    if (strInstance->len < 0){
      calcStringInfo();
    }
    return strInstance->len;
  }
  ////////////////////////
  // ˤ
  void empty();
  ////////////////////////
  // ɤĴ٤
  bool isEmpty() const {
    return (countLetter() <= 0);
  }
  
protected:

private:
  ////////////////////////
  // lastzone, lenη׻Ԥ
  void calcStringInfo() const;
  ////////////////////////
  // refcount򲼤ȡstrInstance
  void freeInstance();
  ////////////////////////
  // refcount1Ǥ뤳Ȥݾڤ
  void forceUnique();
  ////////////////////////
  // ʸХåեݤ
  //   [in] size - ʸΰκ㥵(ºݤ;ʬ˳ݤ)
  YStringInstance* allocNewBuffer(int size);
  ////////////////////////
  // ʸΤؤΥݥ
  YStringInstance* strInstance;
  
};

#endif // DEFINE_H_YSTRING
