/**
 * @file ywindow.CC
 * @brief ݥɥ ()
 *
 * @author Yashiro Takeshi <yashiromann@nifty.com> 
 * @date 2004-01-28
 *
 * Copyright (C) 2003-2004, Yashiro Takeshi
 */

#include "ywindow.h"
#include "yapplication.h"
#include "yglobaldefs.h"

#define pictogram_number

/** ɥΥȥ
 *
 * ɥΥȥꤷޤ
 * @param tcstr ȥ
 */
void YWindow::setTitle(const YString& tcstr)
{
  title = tcstr;
  if (windowID > 0){
    wset_tit(windowID,2,const_cast<TC*>((const TC*)title),0);
  }
}

/** ɥ򳫤
 *
 * ɥ򳫤ɽޤ
 * @throw YWindowException ɥ˼
 */
void YWindow::openWindow()
{
  windowID = wopn_wnd(winAttr, 0, (RECT*)&position, NULL, pictogram,
                      const_cast<TC*>((const TC*)title), NULL, NULL);
  if (windowID < 0){
    YString msg((TC[]){L"ɥ˼Ԥޤ"});
    throw new YWindowException(msg, windowID);
  }
  wreq_dsp(windowID);
}

/** ɥĤ
 *
 * ɥĤɽˤޤ
 */
void YWindow::closeWindow()
{
  setpointer(PS_BUSY,NULL);
  if (windowID > 0){
    wcls_wnd(windowID,CLR);
  }
  windowID = -1;
  
  // ϥᥤ󥦥ɥξΤߤɡȤꤢ
  app->terminate(0); // terminate with return code
}

/** ɥ°
 *
 * ɥ°Ԥޤɥɽ
 * Ȥ˸¤äƻѲǽǤ뤳ȤդƤ<br>
 * (ɥ° WA_STD, WA_NORMAL 뤤ϡ
 * WA_FRONT, WA_SUBW, WA_SIZE, WA_HHDL, WA_VHDL, WA_RBAR, WA_BBAR, 
 * WA_LBAR, WA_TITL, WA_BGDSP, WA_FULL, WA_SFULL, WA_STD, WA_WORK,
 * WA_FRAME, WA_FMOVE. And also, WA_STD, WA_NORMAL
 *  OR ꤷޤ
 * @param wa ɥ°
 * @throw YWindowException ɥɽλ˸¤äƻѲǽǤ
 */
void YWindow::setAttributes(UW wa)
{
  winAttr = wa;
  if (windowID > 0){
    YString msg((TC[]){L"ɥ°ϥɥƤ֤ǤѹǤޤ"});
    throw new YWindowException(msg, windowID);
  }
}

/** 襤٥ȤΥϥɥ
 *
 * 襤٥ȤФϥɥǤ̤Ϥ򥪡С饤ɤ
 * ɬפϤʤŪ˸ƤӽФƤonDrawؿ򥪡С饤ɤ
 * 
 */
void YWindow::onRepaint()
{
  YGraphic *gr = createGraphic();

  do {
    if (wsta_dsp(windowID,NULL,NULL) == 0){
      break;
    }
    wera_wnd(windowID, NULL);
    cdsp_pwd(windowID, NULL, P_RDISP);
    onDraw(gr);
  } while (wend_dsp(windowID) > 0);
  
  delete gr;
}

void YWindow::onMouseButtonDown(WEVENT *ev)
{
  W clt = wchk_dck(ev->s.time);
  W mode;
  
  switch (ev->s.cmd){
  case W_WORK:
    // TODO: ν˰ܴ
    break;
    
  case W_LTHD:
  case W_LBHD:
  case W_RTHD:
  case W_RBHD:
    {
      if (clt == W_DCLICK){
        if (wchg_wnd(ev->s.wid, (RECT*)&position, W_MOVE) == W_FULL){
          RECT rect;
          W gid = wget_gid(windowID);
          wget_wrk(windowID, &rect);
          if (rect.c.left != 0 || rect.c.top != 0){
            wscr_wnd(windowID, NULL, -rect.c.left, -rect.c.right, W_MOVE | W_RDSET);
            rect.c.right -= rect.c.left; rect.c.left = 0;
            rect.c.bottom -= rect.c.top; rect.c.top = 0;
          }
          wset_wrk(windowID, &rect);
          gset_vis(gid, rect);
          onRepaint();
        }
      }
      else if (clt == W_PRESS || clt == W_QPRESS){
        wrsz_drg(ev, NULL, (RECT*)&position); // update flag..
        RECT rect;
        W gid = wget_gid(windowID);
        wget_wrk(windowID, &rect);
        if (rect.c.left != 0 || rect.c.top != 0){
          wscr_wnd(windowID, NULL, -rect.c.left, -rect.c.right, W_MOVE | W_RDSET);
          rect.c.right -= rect.c.left; rect.c.left = 0;
          rect.c.bottom -= rect.c.top; rect.c.top = 0;
        }
        wset_wrk(windowID, &rect);
        gset_vis(gid, rect);
        onRepaint();
      }
      // nothing to be done for W_CLICK
    }
    break;
    
  case W_PICT:
    if (clt == W_DCLICK){
      closeWindow();
    }
    else if (clt == W_CLICK){
      break; // no-operation
    }
  case W_TITL:
  case W_FRAM:
    if (clt == W_PRESS || clt == W_QPRESS){ // ɲ
      if (wmov_drg(ev,NULL) > 0){
        onRepaint();
      }
    }
    break;
    
  case W_RBAR:
  case W_LBAR:
  case W_BBAR:
    // scroll-bars
    break;
    
  case W_SWITCH:
    // ΰΰĤȽ񤤤Ƥ뤱ɡ
    break;
    
  case W_CLOSED:
    // ҥɥĤ
    break;
    
  }
}

